%define apache_version 2.0.54
%define svn_version 1.2.3
%define jdk_path %{_libdir}/jvm/java-1.4.2-gcj
# Rpm macro is wrong for py_sitedir and 64 archs, so using a tmp macro
%define pysite %{py_prefix}/%_lib/python%{py_ver}/site-packages
%define swigdirs swig_pydir=%{pysite}/libsvn swig_pydir_extra=%{pysite}/svn
%define perl_man3dir %(perl -e 'use ExtUtils::MM; $MM = new ExtUtils::MM({q(NORECURS)=>1}); $m3d = $MM->{INSTALLVENDORMAN3DIR}; $m3d =~ s/\\$\\(([^\\)]+)\\)/$MM->{$1}/g; print "$m3d\\n"; package ExtUtils::MakeMaker; sub flush { return q();}; sub check_manifest { return q();}; package ExtUtils::MM; sub guess_name { return q(foo); } sub parse_version { return q(1.0); }')

%define build_python 1
%{?_without_python: %{expand: %%global build_python 0}}

%define build_ruby 1
%{?_without_ruby %{expand: %%global build_ruby 0}}

%define build_java 0
%{?_without_java %{expand: %%global build_java 0}}

%define build_perl 1
%{?_without_perl: %{expand: %%global build_perl 0}}

%define build_test 0
%{?_with_test: %{expand: %%global build_test 1}}

Name: subversion
Summary: A Concurrent Versioning system similar to but better than CVS
Version: %{svn_version}
Release: 1mdk
License: BSD
Group: Development/Other
URL: http://subversion.tigris.org
Source0: http://subversion.tigris.org/tarballs/%{name}-%{svn_version}.tar.bz2
Source1:	http://subversion.tigris.org/tarballs/%{name}-%{svn_version}.tar.bz2.asc
Source2:	%{mod_dav_conf}.bz2
Source3:	%{mod_authz_conf}.bz2
Patch0: subversion-1.1.3-java.patch
BuildRequires: autoconf2.5 >= 2.54
BuildRequires: libtool >= 1.4.2
BuildRequires: chrpath
BuildRequires: python >= 2.2
BuildRequires: texinfo
BuildRequires: info-install
BuildRequires: db4-devel
BuildRequires: neon-devel = 0.24.7
BuildRequires: apache-devel >=  %{apache_version}
BuildRequires: libxslt-proc
BuildRequires: docbook-style-xsl
BuildRequires: swig-devel >= 1.3.19 
%if %{build_perl}
BuildPreReq: perl-devel
%endif
%if %{build_python}
%py_requires -d
%endif
%if %{build_ruby}
BuildPreReq: ruby-devel
%endif
%if %{build_java}
BuildPreReq: java-1.4.2-gcj-compat
BuildPreReq: java-1.4.2-gcj-compat-devel
%endif
%if %mdkversion >= 1020
BuildRequires:	multiarch-utils >= 1.0.3
%endif
# Obsoletes - kill all non sys build library packages
# Just server and client need some libraries and we need just one
# main ( client ) and one server package, as well bindings and doc packages
Obsoletes: %{name}-client-tools <= 1.2.1
Obsoletes: %{name}-repos <= 1.2.1
Obsoletes: libsvn_client1_0 <= 1.2.1
Obsoletes: libsvn_ra_dav1_0 <= 1.2.1
Obsoletes: libsvn_ra_local1_0 <= 1.2.1
Obsoletes: libsvn_ra_svn1_0 <= 1.2.1
Obsoletes: libsvn_delta1_0 <= 1.2.1
Obsoletes: libsvn_diff1_0 <= 1.2.1
Obsoletes: libsvn_repos1_0 <= 1.2.1
Obsoletes: libsvn_subr1_0 <= 1.2.1
Provides: subversion-ra-method = %{version}-%{release}
BuildRoot: %{_tmppath}/%{name}-%{svn_version}


%description
Subversion is a concurrent version control system which enables one or more
users to collaborate in developing and maintaining a hierarchy of files and
directories while keeping a history of all changes.  Subversion only stores the
differences between versions, instead of every complete file.  Subversion also
keeps a log of who, when, and why changes occured.

As such it basically does the same thing CVS does (Concurrent Versioning
System) but has major enhancements compared to CVS and fixes a lot of the
annoyances that CVS users face.

This package contains the client, if you're looking for the server end
of things you want %{name}-repos.  You'll want to install
%{libsvn_ra_dav_name} or %{libsvn_ra_local_name} or %{libsvn_ra_svn_name}
to access HTTP/DAV or local or svnserve respositories, respectively.

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files 
%defattr(-,root,root)
%{_bindir}/svn
%{_bindir}/svnversion
%{_bindir}/server-vsn*
%{_bindir}/showchange*
%{_bindir}/search-svnlog*
%{_bindir}/svn_all_diffs*
%{_bindir}/svn_load_dirs*
%{_bindir}/svn-log*
%{_bindir}/svnlook
%config(noreplace) %{_sysconfdir}/bash_completion.d/svn
%{_libdir}/libsvn_ra*.so.*
%{_libdir}/libsvn_client*so.*
%{_libdir}/libsvn_wc-*so.*
%{_libdir}/libsvn_delta-*so.*
%{_libdir}/libsvn_subr-*so.*
%{_libdir}/libsvn_diff-*so.*
%{_datadir}/locale/*/*/*
%{_datadir}/emacs/site-lisp/vc-svn.el
%{_datadir}/emacs/site-lisp/psvn.el
%{_mandir}/man1/svn*
%if %mdkversion <= 910
    # Already included in vim-common on 9.2 and newer.
    %{_datadir}/vim/syntax/svn.vim
%endif

#--------------------------------------------------------------

%package	doc
Summary: Subversion Documenation
Group: Development/Other

%description	doc
Subversion is a concurrent version control system which enables
one or more users to collaborate in developing and maintaining a
hierarchy of files and directories while keeping a history of all
changes. Subversion only stores the differences between versions,
instead of every complete file. Subversion also keeps a log of
who, when, and why changes occured.
As such it basically does the same thing CVS does (Concurrent
Versioning System) but has major enhancements compared to CVS and
fixes a lot of the annoyances that CVS users face.
This package contains the subversion book and design info files.

%post doc
%_install_info svn-design.info
%_install_info svn-handbook.info

%postun doc
%_install_info svn-design.info
%_install_info svn-handbook.info

%files doc
%defattr(-,root,root)
%doc html/*
%attr(0644,root,root) %{_infodir}/*

#--------------------------------------------------------------

%package	server
Summary: Subversion Server
Group: System/Servers
Requires: %{name} = %{svn_version}-%{release}
Requires(pre,postun): rpm-helper
Requires: xinetd
Obsoletes: libsvn_fs_fs1_0 <= 1.2.1
Obsoletes: libsvn_fs_base1_0 <= 1.2.1
Obsoletes: libsvn_repos1_0 <= 1.2.1
Obsoletes: %{name}-repos <= 1.2.1

%description server
This package contains a myriad of server for subversion server
and repository admins:
  * hot-backup makes a backup of a svn repo without stopping
  * mirror_dir_through_svn.cgi 
  * various hook scripts
  * xslt example 

Note that cvs2svn has moved out of subversion and is a separate
project.  It has not released its own package yet, but you can
find it at http://cvs2svn.tigris.org/

%pre server
%_pre_useradd svn %{_localstatedir}/svn /bin/false

%post server
# Libraries for REPOS ( Repository ) and FS ( filesystem backends ) are in
# server now, so we need a ldconfig
/sbin/ldconfig
# this logic was taken from the distcc package
# check that /etc/services has been already patched with svnserve port
CHECK_PORT=`grep svnserve %{_sysconfdir}/services`
if [ -z "$CHECK_PORT" ]; then
    echo "# svnserve ports added by %{name}-server" >> %{_sysconfdir}/services
    echo -e "svnserve\t3690/tcp\t\t\t# Subversion svnserve" >> %{_sysconfdir}/services
    echo -e "svnserve\t3690/udp\t\t\t# Subversion svnserve" >> %{_sysconfdir}/services
fi

# restarting xinetd service
service xinetd condrestart

%postun server
%_postun_userdel svn
# restarting xinetd service
service xinetd condrestart
/sbin/ldconfig

%files server
%defattr(-,root,root)
%doc BUGS CHANGES COMMITTERS COPYING HACKING INSTALL README
%doc notes/repos_upgrade_HOWTO
%{_bindir}/svnadmin
%{_bindir}/svnserve
%{_bindir}/svndumpfilter
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/xinetd.d/svnserve
%attr(0755,svn,svn) %dir %{_localstatedir}/svn
%attr(0755,svn,svn) %dir %{_localstatedir}/svn/repositories
%{_libdir}/libsvn_fs*.so.*
%{_libdir}/libsvn_repos-*.so.*
%{_mandir}/man1/svnadmin.1*
%{_mandir}/man8/svnserve.8*
%{_mandir}/man5/svnserve.conf.5*
%{_mandir}/man1/svndumpfilter.1*


#--------------------------------------------------------------

%package	tools
Summary: Subversion Repo/Server Tools
Group: Development/Other
Requires: %{name}-server =  %{svn_version}-%{release}
Obsoletes: %{name}-repo-tools < %{svn_version}-%{release}

%description tools
This package contains a myriad of tools for subversion server
and repository admins:
  * hot-backup makes a backup of a svn repo without stopping
  * mirror_dir_through_svn.cgi 
  * various hook scripts
  * xslt example 

Note that cvs2svn has moved out of subversion and is a separate
project.  It has not released its own package yet, but you can
find it at http://cvs2svn.tigris.org/

%files tools
%defattr(-,root,root)
%{_bindir}/hot-backup*
%dir %{_datadir}/%{name}-%{svn_version}/repo-tools
%{_datadir}/%{name}-%{svn_version}/repo-tools/*

#----------------------------------------------------------------
%if %{build_python}

%package -n	python-svn
Summary:	Python bindings for Subversion
Group: Development/Other
Provides: python-subversion = %{svn_version}-%{release}
Requires: %{name} = %{svn_version}-%{release}

%description -n python-svn
This package contains the files necessary to use the subversion
library functions within python scripts.

%files -n python-svn
%defattr(-,root,root)
%doc subversion/bindings/swig/INSTALL subversion/bindings/swig/NOTES
%doc tools/examples/*.py
%{_libdir}/libsvn_swig_py*.so.*
%dir %{pysite}/svn
%{pysite}/svn/*.py*
%dir %{pysite}/libsvn
%{pysite}/libsvn/*.py*
%{pysite}/libsvn/*.so


%package -n	python-svn-devel
Summary:	Python bindings for Subversion, development files
Group: Development/Other
Requires: python-svn = %{svn_version}-%{release}
Obsoletes: python-svn-static-devel <= 1.2.1
Provides: python-subversion-devel = %{svn_version}-%{release}

%description -n python-svn-devel
This package contains the .la files for the python bindings for
subversion.  It's likely nobody will ever need these.

%files -n python-svn-devel
%defattr(-,root,root)
%{pysite}/libsvn/*.la
%{_libdir}/libsvn_swig_py*.so

%endif

#----------------------------------------------------------------

%if %{build_ruby}

%package -n	ruby-svn
Summary:	Ruby bindings for Subversion
Group: Development/Other
Requires: ruby
Provides: ruby-subversion = %{svn_version}-%{release}
Requires: %{name} = %{svn_version}-%{release}

%description -n	ruby-svn
This package contains the files necessary to use the subversion
library functions within ruby scripts.

%package -n	ruby-svn-devel
Summary:	Ruby bindings for Subversion, development libraries
Group:		Development/Other

%description -n	ruby-svn-devel
This package contains the .la files for the ruby bindings for
subversion.  It's likely nobody will ever need these.

%files -n ruby-svn
%defattr(-,root,root)
%{_libdir}/ruby/site_ruby/*/*/*/*/*.so
%{_libdir}/ruby/site_ruby/*/*/*.rb
%{_libdir}/libsvn_swig_ruby*.so.*

%files -n ruby-svn-devel
%defattr(-,root,root)
%{_libdir}/ruby/site_ruby/*/*/*/*/*.la
%{_libdir}/libsvn_swig_ruby*.so

%endif

#----------------------------------------------------------------

%if %{build_java}

%package -n	java-svn
Summary:	java bindings for Subversion
Group: Development/Other
Requires: java
Provides: java-subversion = %{svn_version}-%{release}
Requires: %{name} = %{svn_version}-%{release}

%description -n	java-svn
This package contains the files necessary to use the subversion
library functions within java scripts.

%files -n java-svn
%defattr(-,root,root)
%{_libdir}/libsvnjavahl-1.*
%{_libdir}/svn-javahl

%endif


#----------------------------------------------------------------

%package -n	perl-svn
Summary:	Perl bindings for Subversion
Group: Development/Perl
Requires: %{name} = %{svn_version}-%{release}
Obsoletes: perl-SVN <= 1.2.1

%description -n	perl-svn
This package contains the files necessary to use the subversion
library functions within perl scripts.

%files -n perl-svn
%defattr(-,root,root)
%doc subversion/bindings/swig/INSTALL subversion/bindings/swig/NOTES
%{_libdir}/libsvn_swig_perl*.so.*
%dir %{perl_vendorarch}/SVN
%{perl_vendorarch}/SVN/*
%dir %{perl_vendorarch}/auto/SVN
%{perl_vendorarch}/auto/SVN/*
%{perl_man3dir}/SVN::*.3*


%package -n	perl-svn-devel
Summary:	Perl bindings for Subversion, development files 
Group:		Development/Other
Requires:	perl-svn = %{svn_version}-%{release}      
Obsoletes: perl-SVN-devel <= 1.2.1

%description -n perl-svn-devel
This package contains the .so files for the perl bindings for
subversion.  It's likely nobody will ever need these.

%files -n perl-svn-devel
%defattr(-,root,root)
%{_libdir}/libsvn_swig_perl*.so

#----------------------------------------------------------------

%package devel
Summary:	Subversion headers/libraries for development
Group: Development/Other
Provides: libsvn-devel = %{svn_version}-%{release}
Obsoletes: libsubversion1_0-devel <= 1.2.1
Obsoletes: libsubversion1_0-static-devel <= 1.2.1

%description devel
This package contains the header files and linker scripts for
subversion libraries.

%files devel
%defattr(-,root,root)
%doc tools/examples/minimal_client.c
%if %mdkversion >= 1020
%multiarch %{multiarch_bindir}/svn-config
%endif
%{_bindir}/svn-config
%{_libdir}/libsvn*.la
%{_includedir}/subversion*/*
%{_libdir}/libsvn_*.so

#----------------------------------------------------------------

%define mod_version  %{apache_version}_%{svn_version}
%define mod_dav_name mod_dav_svn
%define mod_dav_conf 46_%{mod_dav_name}.conf
%define mod_dav_so %{mod_dav_name}.so
%define mod_authz_name mod_authz_svn
%define mod_authz_conf 47_%{mod_authz_name}.conf
%define mod_authz_so %{mod_authz_name}.so

%package -n	apache-mod_dav_svn
Summary:	Subversion server DSO module for apache
Version:	%{mod_version}	
Group:System/Servers
Requires: %{name}-server = %{svn_version}-%{release}
Requires(pre,postun): rpm-helper
Requires(pre):	apache-conf >= %{apache_version}
Requires(pre):	apache >= %{apache_version}
Requires(pre):	apache-mod_dav >= %{apache_version}
Provides: apache2-%{mod_dav_name} = %{mod_version}
Obsoletes: apache2-mod_dav_svn
Obsoletes: apache-mod_authz_svn

%description -n apache-mod_dav_svn
Subversion is a concurrent version control system which enables
one or more users to collaborate in developing and maintaining a
hierarchy of files and directories while keeping a history of all
changes. Subversion only stores the differences between versions,
instead of every complete file. Subversion also keeps a log of
who, when, and why changes occured.

As such it basically does the same thing CVS does (Concurrent
Versioning System) but has major enhancements compared to CVS and
fixes a lot of the annoyances that CVS users face.

This package contains the apache server extension DSO for running
a subversion server.

%post -n apache-mod_dav_svn
if [ -f %{_var}/lock/subsys/httpd ]; then
    %{_initrddir}/httpd restart 1>&2;
fi

%postun -n apache-mod_dav_svn
if [ "$1" = "0" ]; then
    if [ -f %{_var}/lock/subsys/httpd ]; then
	%{_initrddir}/httpd restart 1>&2
    fi
fi

%files -n apache-mod_dav_svn
%defattr(-,root,root)
%doc subversion/%{mod_authz_name}/INSTALL
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/httpd/modules.d/%{mod_dav_conf}
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/httpd/modules.d/%{mod_authz_conf}
%attr(0755,root,root) %{_libdir}/apache-extramodules/%{mod_dav_so}
%attr(0755,root,root) %{_libdir}/apache-extramodules/%{mod_authz_so}
%attr(0644,root,root) %{_var}/www/icons/subversion.png

#----------------------------------------------------------------
%prep

%setup -q
%if %{build_java}
%patch0 -p1 -b .java
%endif

rm -rf neon apr apr-util db4

# fix shebang lines, #111498
perl -pi -e 's|/usr/bin/env perl -w|/usr/bin/perl -w|' tools/hook-scripts/*.pl.in

%build
./autogen.sh

export CFLAGS="-fPIC"
export CXXFLAGS="-fPIC"
# override weird -shrext from ruby ( from Fedora )
export svn_cv_ruby_link="%{__cc} -shared"
export JAVA_HOME=%{jdk_home}

./configure \
	--prefix=%{_prefix} \
	--sysconfdir=%{_sysconfdir} \
	--datadir=%{_datadir} \
   --libdir=%_libdir \
	--localstatedir=%{_localstatedir} \
	--mandir=%{_mandir} \
    --with-apxs=%{_sbindir}/apxs \
    --disable-mod-activation \
    --with-swig=%{_prefix} \
    --disable-static \
%if %{build_ruby}
    --with-ruby-sitedir=%{_libdir}/ruby/site_ruby \
%endif
    --enable-shared \
	 --enable-dso

# put the apache modules in the correct place
perl -pi -e "s|%{_libdir}/apache|%{_libdir}/apache-extramodules|g" Makefile subversion/mod_authz_svn/*la subversion/mod_dav_svn/*la

%make all

%if %{build_python}
%make swig-py %{swigdirs}
%endif

%if %{build_perl}
%make swig-pl
%endif

%if %{build_ruby}
%make swig-rb
%endif

%if %{build_java}
# No distcc here
make javahl
%endif

pushd doc
# the perl script works around a bug in the html-stylesheet.xsl
%{__perl} -pi -e 's#href="xsl/(html/docbook.xsl)"#href="%{_datadir}/sgml/docbook/xsl-stylesheets/$1"#;' tools/html-stylesheet.xsl
%{__perl} -pi -e 's#href="xsl/(html/chunk.xsl)"#href="%{_datadir}/sgml/docbook/xsl-stylesheets/$1"#;' tools/chunk-stylesheet.xsl
%{__perl} -pi -e 's#href="xsl/(fo/docbook.xsl)"#href="%{_datadir}/sgml/docbook/xsl-stylesheets/$1"#;' tools/fo-stylesheet.xsl
%make all-html
popd

%install
%{__rm} -rf %{buildroot}

%if %{build_test}
echo "###########################################################################"
echo "This can take quite some time to finish, so please be patient..."
echo "Don't be too surprised it the tests takes 30 minutes on a dual xeon machine..."
make LD_LIBRARY_PATH="`pwd`/subversion/bindings/swig/perl/libsvn_swig_perl/.libs:`pwd`/subversion/bindings/swig/python/libsvn_swig_py/.libs:\
`pwd`/subversion/bindings/swig/python/.libs:`pwd`/subversion/libsvn_ra_local/.libs:`pwd`/subversion/svnadmin/.libs:\
`pwd`/subversion/tests/libsvn_ra_local/.libs:`pwd`/subversion/tests/libsvn_fs/.libs:`pwd`/subversion/tests/libsvn_wc/.libs:\
`pwd`/subversion/tests/libsvn_fs_base/.libs:`pwd`/subversion/tests/libsvn_diff/.libs:`pwd`/subversion/tests/libsvn_subr/.libs:\
`pwd`/subversion/tests/libsvn_delta/.libs:`pwd`/subversion/tests/libsvn_repos/.libs:`pwd`/subversion/tests/.libs:\
`pwd`/subversion/svnserve/.libs:`pwd`/subversion/libsvn_fs/.libs:`pwd`/subversion/libsvn_ra/.libs:`pwd`/subversion/libsvn_wc/.libs:\
`pwd`/subversion/mod_dav_svn/.libs:`pwd`/subversion/mod_authz_svn/.libs:`pwd`/subversion/svnlook/.libs:`pwd`/subversion/svndumpfilter/.libs:\
`pwd`/subversion/libsvn_client/.libs:`pwd`/subversion/libsvn_fs_base/bdb/.libs:`pwd`/subversion/libsvn_fs_base/util/.libs:\
`pwd`/subversion/libsvn_fs_base/.libs:`pwd`/subversion/libsvn_diff/.libs:`pwd`/subversion/libsvn_subr/.libs:`pwd`/subversion/svnversion/.libs:\
`pwd`/subversion/libsvn_ra_dav/.libs:`pwd`/subversion/libsvn_ra_svn/.libs:`pwd`/subversion/libsvn_delta/.libs:`pwd`/subversion/libsvn_fs_fs/.libs:\
`pwd`/subversion/libsvn_repos/.libs:`pwd`/subversion/clients/cmdline/.libs:$LD_LIBRARY_PATH" check
%endif

%makeinstall_std

%if %{build_python}
%makeinstall_std install-swig-py %{swigdirs}
%endif
%if %{build_perl}
%makeinstall_std install-swig-pl-lib
%endif
%if %{build_ruby}
%makeinstall_std install-swig-rb
%endif
%if %{build_java}
%makeinstall_std install-javahl
%endif

# perl bindings
make pure_vendor_install -C subversion/bindings/swig/perl/native 

# The install isn't installing the info files now, I tried patching the 
# Makefile to get it to and couldn't get it to work.  So I give up and
# did it myself.  Maybe they'll fix it sometime in the future.
%{__install} -d %{buildroot}%{_infodir}
%{__install} -m644 doc/programmer/design/svn-design.info %{buildroot}%{_infodir}
[ -r doc/programmer/design/svn-design.info-1 ] && %{__install} -m644 doc/programmer/design/svn-design.info-1 %{buildroot}%{_infodir}
[ -r doc/programmer/design/svn-design.info-2 ] && %{__install} -m644 doc/programmer/design/svn-design.info-2 %{buildroot}%{_infodir}
[ -r doc/programmer/design/svn-design.info-3 ] && %{__install} -m644 doc/programmer/design/svn-design.info-3 %{buildroot}%{_infodir}

install -d %{buildroot}%{_sysconfdir}/httpd/modules.d
bzcat %{SOURCE2} > %{buildroot}%{_sysconfdir}/httpd/modules.d/%{mod_dav_conf}
bzcat %{SOURCE3} > %{buildroot}%{_sysconfdir}/httpd/modules.d/%{mod_authz_conf}

######################
###  client-tools  ###
######################

# vim syntax hilighting
%if %mdkversion <= 910
    # Already included in vim-common on 9.2 and newer.
    %{__install} -d -m 755 %{buildroot}/%{_datadir}/vim/syntax
    %{__install} -m 644 contrib/client-side/svn.vim %{buildroot}/%{_datadir}/vim/syntax
%endif

# emacs vc interface
%{__install} -d -m 755 %{buildroot}/%{_datadir}/emacs/site-lisp
%{__install} -m 644 contrib/client-side/vc-svn.el %{buildroot}/%{_datadir}/emacs/site-lisp

# psvn
%{__install} -m 644 contrib/client-side/psvn/psvn.el %{buildroot}/%{_datadir}/emacs/site-lisp

# various commands
%{__install} -m 755 contrib/client-side/search-svnlog.pl %{buildroot}%{_bindir}
(cd  %{buildroot}/%{_bindir}; %{__ln_s} search-svnlog.pl search-svnlog)
%{__install} -m 755 contrib/client-side/svn_all_diffs.pl %{buildroot}%{_bindir}
(cd  %{buildroot}/%{_bindir}; %{__ln_s} svn_all_diffs.pl svn_all_diffs)
%{__install} -m 755 contrib/client-side/svn_load_dirs.pl %{buildroot}%{_bindir}
(cd  %{buildroot}/%{_bindir}; %{__ln_s} svn_load_dirs.pl svn_load_dirs)
%{__install} -m 755 contrib/client-side/svn-log.pl %{buildroot}%{_bindir}
(cd  %{buildroot}/%{_bindir}; %{__ln_s} svn-log.pl svn-log)
%{__install} -m 755 tools/client-side/server-vsn.py %{buildroot}%{_bindir}
(cd  %{buildroot}/%{_bindir}; %{__ln_s} server-vsn.py server-vsn)
%{__install} -m 755 tools/client-side/showchange.pl %{buildroot}%{_bindir}
(cd  %{buildroot}/%{_bindir}; %{__ln_s} showchange.pl showchange)

# bash completion
%{__install} -d -m 755 %{buildroot}%{_sysconfdir}/bash_completion.d
%{__install} -m 644 tools/client-side/bash_completion %{buildroot}%{_sysconfdir}/bash_completion.d/svn

####################
###  repo-tools  ###
####################

# hotbackup tool
%{__install} -m 755 tools/backup/hot-backup.py %{buildroot}%{_bindir}
(cd %{buildroot}%{_bindir}; %{__ln_s} hot-backup.py hot-backup)

# hook-scripts
%{__install} -d -m755 %{buildroot}%{_datadir}/%{name}-%{svn_version}/repo-tools/hook-scripts
%{__install} -m 644 tools/hook-scripts/commit-access-control.cfg.example %{buildroot}/%{_datadir}/%{name}-%{svn_version}/repo-tools/hook-scripts
%{__install} -m 755 tools/hook-scripts/commit-access-control.pl %{buildroot}/%{_datadir}/%{name}-%{svn_version}/repo-tools/hook-scripts
%{__install} -m 755 tools/hook-scripts/commit-email.pl %{buildroot}/%{_datadir}/%{name}-%{svn_version}/repo-tools/hook-scripts
%{__install} -m 755 tools/hook-scripts/propchange-email.pl %{buildroot}/%{_datadir}/%{name}-%{svn_version}/repo-tools/hook-scripts
%{__install} -m 644 tools/hook-scripts/svnperms.conf.example %{buildroot}/%{_datadir}/%{name}-%{svn_version}/repo-tools/hook-scripts
%{__install} -m 755 tools/hook-scripts/svnperms.py %{buildroot}/%{_datadir}/%{name}-%{svn_version}/repo-tools/hook-scripts
%{__install} -m 755 tools/hook-scripts/mailer/mailer.py %{buildroot}/%{_datadir}/%{name}-%{svn_version}/repo-tools/hook-scripts
%{__install} -m 644 tools/hook-scripts/mailer/mailer.conf.example %{buildroot}/%{_datadir}/%{name}-%{svn_version}/repo-tools/hook-scripts
%{__install} -m 644 tools/hook-scripts/README %{buildroot}/%{_datadir}/%{name}-%{svn_version}/repo-tools/hook-scripts

#xslt
%{__install} -d -m755 %{buildroot}%{_datadir}/%{name}-%{svn_version}/repo-tools/xslt
%{__install} -m 644 tools/xslt/svnindex.css %{buildroot}%{_datadir}/%{name}-%{svn_version}/repo-tools/xslt
%{__install} -m 644 tools/xslt/svnindex.xsl %{buildroot}%{_datadir}/%{name}-%{svn_version}/repo-tools/xslt

#cgi
%{__install} -d -m755 %{buildroot}%{_datadir}/%{name}-%{svn_version}/repo-tools/cgi
%{__install} -m 755 contrib/cgi/mirror_dir_through_svn.cgi %{buildroot}%{_datadir}/%{name}-%{svn_version}/repo-tools/cgi
%{__install} -m 644 contrib/cgi/mirror_dir_through_svn.README %{buildroot}%{_datadir}/%{name}-%{svn_version}/repo-tools/cgi
%{__install} -m 755 contrib/cgi/tweak-log.cgi %{buildroot}%{_datadir}/%{name}-%{svn_version}/repo-tools/cgi

# "install" the html docs...
pushd doc
    rm -rf html
    %{__make} INSTALL_DIR="../html" install-misc-html
    cp book/*.html ../html/
    cp user/*.html ../html/
    find ../html -type f | xargs %{__chmod} 644
popd

# install a nice icon for web usage
%{__install} -d %{buildroot}/var/www/icons
%{__install} -m644 notes/logo/256-colour/subversion_logo_hor-237x32.png %{buildroot}/var/www/icons/subversion.png

# fix a missing file...
%{__ln_s}nf libsvn_diff-1.so.0.0.0 %{buildroot}%{_libdir}/libsvn_diff.so

# install svn-config
perl -pi -e "s|\@SVN_DB_LIBS\@|-ldb|g" svn-config
perl -pi -e "s|\@SVN_DB_INCLUDES\@|-I%{_includedir}/db4|g" svn-config
%{__install} -m755 svn-config %{buildroot}%{_bindir}

# fix the stupid rpath stuff...
find %{buildroot}%{perl_vendorarch} -type f -name "*.so" | xargs chrpath -d

# handle translations
%find_lang %{name}

# fix the server parts
install -d %{buildroot}%{_sysconfdir}/xinetd.d
cat > svnserve.xinetd << EOF
# default: off
# description: svnserve is the server part of Subversion.
service svnserve
{
    disable		= yes
    port		= 3690
    socket_type		= stream
    protocol		= tcp
    wait		= no
    user		= svn
    server		= %{_bindir}/svnserve
    server_args		= -i -r %{_localstatedir}/svn/repositories
}
EOF
install -m0644 svnserve.xinetd %{buildroot}%{_sysconfdir}/xinetd.d/svnserve
install -d %{buildroot}%{_localstatedir}/svn/repositories

%if %mdkversion >= 1020
%multiarch_binaries %{buildroot}%{_bindir}/svn-config
%endif

# nuke *.pyc files
find %{buildroot} -name "*.pyc" | xargs rm -f

# cleanup
find %{buildroot} -name "perllocal.pod" | xargs rm -f

%clean
%{__rm} -rf %{buildroot}


